#include "resources.h"

// TFT module connections
//sbit TFT_BLED at GPIOA_PDOR.B6;
sbit TFT_CS at GPIOB_PDOR.B20;
char TFT_DataPort at GPIOD_PDOR;
sbit TFT_RD at GPIOB_PDOR.B22;
sbit TFT_RS at GPIOB_PDOR.B21;
sbit TFT_RST at GPIOB_PDOR.B19;
sbit TFT_WR at GPIOB_PDOR.B23;
// End TFT module connections

char error;
char command [3];

void InitMCU(void) {
  TFT_Init_SSD1963_Board_50(800, 480);
  TFT_Set_DBC_SSD1963(255);
  Delay_ms(10);
  TFT_Fill_Screen(CL_WHITE);
  TFT_Set_Font(HandelGothic_BT21x22_Regular, CL_BLACK, FO_HORIZONTAL);
}

void main() {
  InitMCU();
  error = Soft_UART_Init(&GPIOA_PDOR, 4, 6, 1200, 0); // Initialize Soft UART at 1200 bps
  
  Delay_ms(1000);                  // Wait for UART module to stabilize

   while (1) {                     // Endless loop
      command[0] = Soft_UART_Read(&error);
      command[1] = Soft_UART_Read(&error);
      command[2] = Soft_UART_Read(&error);
      Delay_ms(1);
      switch (command[1]) {
         case 'U':  TFT_Fill_Screen(CL_WHITE);
                    TFT_Write_Text("LEFT - UP", 350, 250);
                    break;
         case 'D':  TFT_Fill_Screen(CL_WHITE);
                    TFT_Write_Text("LEFT - DOWN", 350, 250);
                    break;
         case 'u':  TFT_Fill_Screen(CL_WHITE);
                    TFT_Write_Text("RIGHT - UP", 350, 250);
                    break;
         case 'd':  TFT_Fill_Screen(CL_WHITE);
                    TFT_Write_Text("RIGHT - DOWN", 350, 250);
                    break;
         case 'o':  TFT_Fill_Screen(CL_WHITE);
                    TFT_Write_Text("MIDDLE", 350, 250);
                    break;
         default:   TFT_Fill_Screen(CL_WHITE);
                    TFT_Write_Text("ERROR", 350, 250);
                    break;
      }
   }
}