typedef enum {_taLeft, _taCenter, _taRight} TTextAlign;
typedef enum {_tavTop, _tavMiddle, _tavBottom} TTextAlignVertical;

typedef struct Screen TScreen;

typedef struct  Button {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  char          Pen_Width;
  unsigned int  Pen_Color;
  char          Visible;
  char          Active;
  char          Transparent;
  char          *Caption;
  TTextAlign    TextAlign;
  TTextAlignVertical TextAlignVertical;
  const char    *FontName;
  unsigned int  Font_Color;
  char          VerticalText;
  char          Gradient;
  char          Gradient_Orientation;
  unsigned int  Gradient_Start_Color;
  unsigned int  Gradient_End_Color;
  unsigned int  Color;
  char          PressColEnabled;
  unsigned int  Press_Color;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TButton;

typedef struct  Label {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  char          *Caption;
  const char    *FontName;
  unsigned int  Font_Color;
  char          VerticalText;
  char          Visible;
  char          Active;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TLabel;

typedef struct  Box {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  char          Pen_Width;
  unsigned int  Pen_Color;
  char          Visible;
  char          Active;
  char          Transparent;
  char          Gradient;
  char          Gradient_Orientation;
  unsigned int  Gradient_Start_Color;
  unsigned int  Gradient_End_Color;
  unsigned int  Color;
  char          PressColEnabled;
  unsigned int  Press_Color;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TBox;

struct Screen {
  unsigned int           Color;
  unsigned int           Width;
  unsigned int           Height;
  unsigned int           ObjectsCount;
  unsigned int           ButtonsCount;
  TButton                * const code *Buttons;
  unsigned int           LabelsCount;
  TLabel                 * const code *Labels;
  unsigned int           BoxesCount;
  TBox                   * const code *Boxes;
  void          (*OnSwipeLeftPtr)();
  void          (*OnSwipeRightPtr)();
  void          (*OnSwipeUpPtr)();
  void          (*OnSwipeDownPtr)();
  void          (*OnZoomInPtr)();
  void          (*OnZoomOutPtr)();
};

extern   TScreen                Screen1;
extern   TLabel                 Label1;
extern   TButton               Button1;
extern   TButton               Button2;
extern   TBox                   Box1;
extern   TBox                   Box2;
extern   TBox                   Box3;
extern   TBox                   Box4;
extern   TButton                * const code Screen1_Buttons[2];
extern   TLabel                 * const code Screen1_Labels[1];
extern   TBox                   * const code Screen1_Boxes[4];

extern   TScreen                Screen2;
extern   TLabel                 Label2;
extern   TButton               Button3;
extern   TButton               Button4;
extern   TBox                   Box9;
extern   TBox                   Box10;
extern   TBox                   Box11;
extern   TBox                   Box12;
extern   TButton                * const code Screen2_Buttons[2];
extern   TLabel                 * const code Screen2_Labels[1];
extern   TBox                   * const code Screen2_Boxes[4];

extern   TScreen                Screen3;
extern   TLabel                 Label3;
extern   TButton               Button5;
extern   TButton               Button6;
extern   TBox                   Box5;
extern   TBox                   Box6;
extern   TBox                   Box7;
extern   TBox                   Box8;
extern   TButton                * const code Screen3_Buttons[2];
extern   TLabel                 * const code Screen3_Labels[1];
extern   TBox                   * const code Screen3_Boxes[4];

extern   TScreen                Screen4;
extern   TLabel                 Label4;
extern   TButton               Button7;
extern   TButton               Button8;
extern   TBox                   Box13;
extern   TBox                   Box14;
extern   TBox                   Box15;
extern   TBox                   Box16;
extern   TButton                * const code Screen4_Buttons[2];
extern   TLabel                 * const code Screen4_Labels[1];
extern   TBox                   * const code Screen4_Boxes[4];


/////////////////////////
// Events Code Declarations
void Button1OnClick();
void Button2OnClick();
void Button3OnClick();
void Button4OnClick();
/////////////////////////

/////////////////////////////////
// Caption variables Declarations
extern char Label1_Caption[];
extern char Button1_Caption[];
extern char Button2_Caption[];
extern char Box1_Caption[];
extern char Box2_Caption[];
extern char Box3_Caption[];
extern char Box4_Caption[];
extern char Label2_Caption[];
extern char Button3_Caption[];
extern char Button4_Caption[];
extern char Box9_Caption[];
extern char Box10_Caption[];
extern char Box11_Caption[];
extern char Box12_Caption[];
extern char Label3_Caption[];
extern char Button5_Caption[];
extern char Button6_Caption[];
extern char Box5_Caption[];
extern char Box6_Caption[];
extern char Box7_Caption[];
extern char Box8_Caption[];
extern char Label4_Caption[];
extern char Button7_Caption[];
extern char Button8_Caption[];
extern char Box13_Caption[];
extern char Box14_Caption[];
extern char Box15_Caption[];
extern char Box16_Caption[];
/////////////////////////////////

void DrawScreen(TScreen *aScreen);
void DrawButton(TButton *aButton);
void DrawLabel(TLabel *ALabel);
void DrawBox(TBox *ABox);
void Check_TP();
void Start_TP();
void Process_TP_Press(unsigned int X, unsigned int Y);
void Process_TP_Up(unsigned int X, unsigned int Y);
void Process_TP_Down(unsigned int X, unsigned int Y);
