
// TFT module connections
sbit TFT_BLED at GPIOA_PDOR.B4;
sbit TFT_CS at GPIOB_PDOR.B20;
char TFT_DataPort at GPIOD_PDOR;
sbit TFT_RD at GPIOB_PDOR.B22;
sbit TFT_RS at GPIOB_PDOR.B21;
sbit TFT_RST at GPIOB_PDOR.B19;
sbit TFT_WR at GPIOB_PDOR.B23;
// End TFT module connections

void Init_Display() {
  TFT_Init_SSD1963_Board_50(800, 480);
  TFT_Set_DBC_SSD1963(255);
  TFT_Fill_Screen(CL_WHITE);
}
const VREF1 = 2048 ;    // ovde unosimo vrednost referentnog napona u milivoltima
unsigned long temp;
unsigned long result;
char text1[11];
unsigned int i;
char text2[11];

static void Get_ADC(){
  result = 0;
  temp = 0;
  for(i = 0; i<256; i++) {
        temp = temp + ADC0_Get_Sample(16);
        Delay_1ms();
  }
  result = temp >> 8;
  result = (unsigned long)(VREF1 * result) / 4096;
  result = result - 500;
  LongWordToStr(result, text1);
  text2[0] = text1[7];
  text2[1] = text1[8];
  text2[2] = 0x2E;
  text2[3] = text1[9];
  TFT_Set_Brush(1,CL_WHITE,0,0,0,0);
  TFT_Set_Pen(CL_WHITE,1);
  TFT_Rectangle(85,100,115,130);
  TFT_Set_Font(TFT_defaultFont, CL_RED, FO_HORIZONTAL);
  TFT_Write_Text(text2, 85, 100);
  TFT_Write_Text("C", 120, 100);

}

void main() {
   Init_Display();
   SIM_SCGC6 = 0x8000000;
   ADC0_SC1A = 0x10;
   Delay_ms(1000);
   ADC0_Set_Input_Channel(_ADC_CHANNEL_16);
   ADC0_Init();                        // Initialize ADC
   while (1) {
         Get_ADC();
   }
}