
 // TFT module connections
sbit TFT_BLED at GPIOA_PDOR.B4;
sbit TFT_CS at GPIOB_PDOR.B20;
char TFT_DataPort at GPIOD_PDOR;
sbit TFT_RD at GPIOB_PDOR.B22;
sbit TFT_RS at GPIOB_PDOR.B21;
sbit TFT_RST at GPIOB_PDOR.B19;
sbit TFT_WR at GPIOB_PDOR.B23;
// End TFT module connections

void Init_Display() {
  TFT_Init_SSD1963_Board_50(800, 480);
  TFT_Set_DBC_SSD1963(255);
  TFT_Fill_Screen(CL_WHITE);
  TFT_Set_Brush(1,CL_WHITE,0,0,0,0);
  TFT_Set_Pen(CL_WHITE,1);
}



void main() {
  Init_Display();
  Delay_ms(100);
  TFT_Write_Text("Status: ", 120, 100);
  TFT_Write_Text("12V detect: ", 120, 200);
  GPIO_Digital_Input(&GPIOE_PDOR, _GPIO_PINMASK_27);   //STAT LED
  GPIO_Digital_Input(&GPIOE_PDOR, _GPIO_PINMASK_28);   //DC DETECT
  while (1) {
    Delay_ms(1000);
    TFT_Rectangle(180,100,300,300);
    if(GPIOE_PDIR.B27 == 1)
        TFT_Write_Text("Connected", 180, 100);
    else
        TFT_Write_Text("Disconnected", 180, 100);
    if(GPIOE_PDIR.B28 == 1)
        TFT_Write_Text("Not detected", 220, 200);
    else
        TFT_Write_Text("Detected", 220, 200);
   }

}